/***************************************************************************
 *   Copyright (C) 2006 by Ilya Kotov                                      *
 *   forkotov02@hotmail.ru                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PLAYLIST_H
#define PLAYLIST_H

#include <QWidget>

/**
   @author Ilya Kotov <forkotov02@hotmail.ru>
*/

class QMenu;

class Skin;
class ListWidget;
class MediaFile;
class Button;
class PlayListModel;
class PlayListTitleBar;
class PlayListSlider;
class MainWindow;

class PlayList : public QWidget
{
    Q_OBJECT
public:
    PlayList(QWidget *parent = 0);

    ~PlayList();
    void load(MediaFile *);
    void setModel(PlayListModel *);
    void readSettings();

    /*public slots:
        void addDir();*/
    //void addFile();

signals:
    void play();

private slots:
    void showAddMenu();
    void showSubMenu();
    void showSelectMenu(); 
	 void showSortMenu();

private:
    void drawPixmap(int, int);
    void writeSettings();
    void createMenus();
    void createActions();
    QMenu *m_addMenu;
    QMenu *m_subMenu;
    QMenu *m_selectMenu;
	 QMenu *m_sortMenu;
    Button *m_buttonAdd;
    Button *m_buttonSub;
    Button *m_selectButton;
	 Button *m_sortButton;
    Skin *m_skin;
    ListWidget *m_listWidget;
    PlayListModel *m_playListModel;
    PlayListTitleBar *m_titleBar;
    PlayListSlider *m_plslider;
    QList <QAction *> m_actions;
    QPoint m_pos;
    bool m_resize;
    bool m_update;

protected:
    virtual void paintEvent(QPaintEvent *);
    virtual void resizeEvent(QResizeEvent *);
    virtual void mouseMoveEvent(QMouseEvent *);
    virtual void mousePressEvent(QMouseEvent *);
    virtual void mouseReleaseEvent(QMouseEvent *);
    //virtual void enterEvent(QEvent*);
    //virtual void leaveEvent(QEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);

};

#endif
